-- Animation class binding

--[[

void bindAnimationClass(Runtime& runtime)
{
auto lua = sol::state_view(runtime.lua());

auto animation = lua.new_usertype<Animation>
(
"animation",
sol::call_constructor, sol::factories
(
[&runtime] ()
{
return std::make_shared<Animation>();
}
)
);
registerLuaType(animation);

animation["addChannel"] = sol::policies(sol::resolve<Animation::Channel&(const std::string&, Animation::ChannelType)>(&Animation::addChannel), sol::self_dependency());

animation["apply"] = [] (Animation& animation, ECS::Entity& entity, float time, sol::optional<float> blend)
{
animation.apply(entity.registry(), entity.handle(), time, blend ? blend.value() : 1.0f);
};

animation["framerate"] = sol::property(&Animation::getFramerate, &Animation::setFramerate);
animation["duration"] = sol::property(&Animation::duration);

auto key = lua.new_usertype<Animation::Key>(sol::no_constructor);
key["time"] = &Animation::Key::time;
key["value"] = &Animation::Key::value;
key["inTangent"] = &Animation::Key::inTangent;
key["outTangent"] = &Animation::Key::outTangent;

animation["key"] = key;

auto curve = lua.new_usertype<Animation::Curve>(sol::no_constructor);
animation["curve"] = curve;

curve["addKey"] = [] (Animation::Curve& curve, float time, float value, sol::variadic_args args)
{
curve.addKey(time, value);
};

curve[sol::meta_method::index] = [] (Animation::Curve& curve, size_t index)
{
index--;
if (index >= curve.length()) throw std::runtime_error("invalid curve key index");
return curve.keys[index];
};

curve["length"] = sol::property(&Animation::Curve::length);
curve["duration"] = sol::property(&Animation::Curve::duration);


auto channel = lua.new_usertype<Animation::Channel>(sol::no_constructor);
animation["channel"] = channel;

channel["bool"] = sol::var(Animation::ChannelType::Bool);
channel["float"] = sol::var(Animation::ChannelType::Float);

channel["addKey"] = [] (Animation::Channel& channel, float time, Animation::ChannelValue value)
{
channel.addKey(time, value);            
};

channel["setKeyTangents"] = [] (Animation::Channel& channel, float time, float inTangent, float outTangent)
{
//            channel.addKey(time, value);
};

//        channel["setKeyTangentMode"] = [] (Animation::Channel& channel, float time, Animation::ChannelValue value)
//        {
//            channel.addKey(time, value);
//        };

channel[sol::meta_method::index] = sol::policies([] (Animation::Channel& channel, size_t index)
{
index--;
if (index >= 4) throw std::runtime_error("invalid channel curve index");
return std::ref(channel.curves[index]);
}, sol::self_dependency());

channel["evaluate"] = [] (Animation::Channel& channel, float time, sol::variadic_args args, sol::this_state state)
{
bool norm = args.size() > 0 ? args.get<bool>(0) : false;
return channel.evaluate(time, norm);
};

channel["length"] = sol::property(&Animation::Channel::length);
channel["duration"] = sol::property(&Animation::Channel::duration);
}
--]]